// Copyright (C) 2022 WYATT GROUP
// Please see the AUTHORS file for details.
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program. If not, see <https://www.gnu.org/licenses/>.

import 'package:crud_bloc_example/user_entity.dart';
import 'package:wyatt_crud_bloc/wyatt_crud_bloc.dart';

/// A [CrudCubit] for [User].
class UserStreamingCubit extends CrudCubit<User> {
  final CrudRepository<User> crudRepository;

  UserStreamingCubit(this.crudRepository);

  @override
  DefaultCreate<User>? get createOperation => Create(crudRepository);

  @override
  DefaultDelete? get deleteOperation => Delete(crudRepository);

  @override
  DefaultRead? get readOperation => Streaming(crudRepository);

  @override
  DefaultUpdate? get updateOperation => Update(crudRepository);

  @override
  ModelIdentifier<User> get modelIdentifier => ModelIdentifier(
        getIdentifier: (user) => user.id ?? '',
      );
}
